function [T] = getMeasuredValues(T)

   
   
   if T.antallRLCgrener==1
       
        %%%%%% UTEN transformatorfaktor N %%%%%%   
     
           if T.dim.L==0.0125
               T.properties.f_m = 65.42e3; % mlt
               T.properties.w_m = T.properties.f_m*2*pi; % mlt
               T.properties.f_n = 67.45e3; % mlt
               %T.properties.f_n = 67.85e3; % testing
               T.properties.w_n = T.properties.f_n*2*pi; % mlt
               k_eff_square = 1- (T.properties.f_m/T.properties.f_n)^2;
               k_eff = sqrt(k_eff_square);
               %C_f = 8.3866e-9; % mlt
               C_f = 9.3383e-9; % testing
               C_p = C_f*(1-k_eff_square);
               C = k_eff_square*C_f;
               L = 1/(T.properties.w_m^2*C);
               T.param = struct('C_p',C_p,'R_p',10e3,'R',50.9,'L',L,'C',C);
               T.properties.k_eff = k_eff; 
               

           elseif T.dim.L==0.008
               if strcmp(T.innkapsling,'ja')
                    T.properties.f_m = 60.0e3;% mlt
                    T.properties.w_m = T.properties.f_m*2*pi; % mlt
                    T.properties.f_n = 62.0e3; % mlt
                    T.properties.w_n = T.properties.f_n*2*pi; % mlt
                    k_eff_square = 1- (T.properties.f_m/T.properties.f_n)^2;
                    k_eff = sqrt(k_eff_square);
                    %C_f = 5.1624e-9;% testing
                    C_f = 5.07e-9;% mlt
                    C_p = C_f*(1-k_eff_square);
                    C = k_eff_square*C_f;
                    L = 1/(T.properties.w_m^2*C);
                    T.param = struct('C_p',C_p,'R_p',5.0e4,'R',240,'L',L,'C',C);
                    T.properties.k_eff = k_eff; 
               else
                    T.properties.f_m = 66.57e3;% mlt
                    T.properties.w_m = T.properties.f_m*2*pi; % mlt
                    T.properties.f_n = 70.19e3; % mlt
                    T.properties.w_n = T.properties.f_n*2*pi; % mlt
                    k_eff_square = 1- (T.properties.f_m/T.properties.f_n)^2;
                    k_eff = sqrt(k_eff_square);
                    %C_f = 5.1624e-9;% testing
                    C_f = 5.37e-9;% mlt
                    C_p = C_f*(1-k_eff_square);
                    C = k_eff_square*C_f;
                    L = 1/(T.properties.w_m^2*C);
                    T.param = struct('C_p',C_p,'R_p',5.0e4,'R',57.41,'L',L,'C',C);
                    T.properties.k_eff = k_eff; 
               end
           end
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
   
       %%%%%% MED transformatorfaktor N %%%%%%   
       if strcmp(T.transformator,'ja')
           r = T.dim.r;
           L = T.dim.L;
           t = T.dim.t;
           rho = T.tetthet;
           k_eff = T.properties.k_eff;
           
            A = 2*pi*r*L;
            M = 2*pi*rho*r*L*t;
            N = sqrt(M/T.param.L);
            
            C_m = T.param.C/N^2;
            L_m = M;
            R_m = T.param.R*N^2;
            K = 1/C_m;
            
            T.param.N = N;
            T.param.R = R_m;
            T.param.L = L_m;
            T.param.C = C_m;
            
            T.properties.e33 = (T.param.C_p*t)/(2*pi*r*L*(1-k_eff^2));
            T.properties.s11 = 2*pi*L*t/(r*K);
            T.properties.Y11 = 1/T.properties.s11;
            T.properties.d31 = N*T.properties.s11/(2*pi*L);
            T.properties.M = M;
            T.properties.A = A; 
            T.properties.K = K; 

       end
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
   %%%%%% brukes kun i et tilfelle %%%%%%
   elseif T.antallRLCgrener==2
        %'C_p',8.3419e-9
        
    % Parametere fra mlinger gjort p transducere den 21.2.2013
    C_f = 9.3383e-9; 
    f_1m = 65416;
    C_1m = 0.554e-9;%3.977e-10; % kan tunes
    L_1m = (1/(2*pi*f_1m))^2/ C_1m;
    f_2m = 69968;%69768;
    
    T.properties.f_m =  f_1m; % mlt
    T.properties.w_m = T.properties.f_m*2*pi; % mlt
    
    R_2m = 1/(abs((3.4228e-3+2.4743e-3i)-(634.6e-6+1.129e-3i))); % fra mlinger av diameter p innerste sirkel
    C_2m = 0.7e-10;%C_f-C_p-C_1m; 
    L_2m = (1/(2*pi*f_2m))^2/ C_2m;
    C_p = C_f - C_1m - C_2m; %7.8889e-9; % kan tunes
        T.param = struct('C_p',C_p,'R_p',10e3,'R1',50.9,'L1',L_1m,'C1',C_1m,'R2',R_2m,'L2',L_2m,'C2',C_2m);
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   T.param.L_t_Rs = 0; 
   T.param.L_t = 1e20; 
   
   if strcmp(T.tuning,'ja')
       T.param.L_t = 1/(T.properties.w_m^2*T.param.C_p); 
   end
   
   
   
   
end

