
function [R_a M_a] = getRadiationResistance(f, L, r)
    c_vann = 1500;
    rho_vann = 1000; 
    
    r_k = sqrt((r*L/2));
    
    k = 2*pi*f/c_vann; 
    A = 4*pi*r_k^2;
    
    Z_r = A*rho_vann*c_vann*((k*r_k)^2 + i*k*r_k)/(1 + (k*r_k)^2);
    
    R_a = real(Z_r);
    M_a = imag(Z_r)/(2*pi*f);
end

