function [ x y ] = getValues( T, varargin)
    validnames = {'|Y|', '|Z|','sirkel','Re(Y)','Im(Y)','M_v'};    
    for name = varargin
       validatestring(name{:}, validnames);
    end
    
     Length = 50000; 
     maxFreq = 200000; 
     f = 0 : (maxFreq/Length) : maxFreq - (maxFreq/Length);
    
    
     
     if T.antallRLCgrener==1
         if strcmp(T.transformator,'nei')
              [A_ss,B_ss,C_ss,D_ss] = linmod('VtoZenGrenUtenTransformator');
         elseif strcmp(T.transformator,'ja')
             [A_ss,B_ss,C_ss,D_ss] = linmod('VtoZenGrenMedTransformator');
         end
        
        sys = ss(A_ss,B_ss,C_ss,D_ss);
        [mag,phase] = bode(sys,2*pi*f);
        I_mag = mag(1,:); I_phase = phase(1,:);
        V_mag = mag(2,:); V_phase = phase(2,:);
        I = I_mag.*exp(i*I_phase* pi/180); % converts degrees to radians
        V = V_mag.*exp(i*V_phase* pi/180); % converts degrees to radians
        Z = V./I;
        Y = I./V;
        
        
     elseif T.antallRLCgrener==2
        [A_ss,B_ss,C_ss,D_ss] = linmod('VtoZtoGrenerUtenTransformator');
        sys = ss(A_ss,B_ss,C_ss,D_ss);
        [mag,phase] = bode(sys,2*pi*f);
        I_mag = mag(1,:); I_phase = phase(1,:);
        V_mag = mag(2,:); V_phase = phase(2,:);
        I = I_mag.*exp(i*I_phase* pi/180); % converts degrees to radians
        V = V_mag.*exp(i*V_phase* pi/180); % converts degrees to radians
        Z = V./I;
        Y = I./V;
     end 
     
     
        % En RLC gren, uten transformator
    if strmatch('|Y|', varargin)
        x=f;
        y=abs(Y);
    elseif strmatch('|Z|', varargin)
        x=f;
        y=abs(Z);
    elseif strmatch('sirkel', varargin)
        x=real(Y);
        y=imag(Y);
    elseif strmatch('Re(Y)', varargin)
        x=f;
        y=real(Y);
    elseif strmatch('Im(Y)', varargin)
        x=f;
        y=imag(Y);
    elseif strmatch('M_v', varargin)&& strcmp(T.transformator,'ja')
         x = f; 
         [A_ss2,B_ss2,C_ss2,D_ss2] = linmod('ptoV');
         sys2 = ss(A_ss2,B_ss2,C_ss2,D_ss2);
         [mag2,phase2] = bode(sys2,2*pi*f);
         y = mag2(1,:); M_phase = phase2(1,:);
    end

end

