%% Simuleringer av transducere i forbindelse med masteroppgave vren 2013

% getValues returnerer transducerparametere avhenig av hvilken option som
% er valgt. 
% opt1 = en RLC gren, uten transformator
% opt2 = en RLC gren, med transformator
% opt3 = to RLC gren, uten transformator

clear; clc; 
T1 = struct('param',struct(),'antallRLCgrener',1,'transformator','ja','tuning','ja','innkapsling','ja','dim',struct('L',0.0125,'r',0.0068,'t',0.001),'tetthet',7700);
T2 = struct('param',struct(),'antallRLCgrener',2,'transformator','nei','tuning','nei','dim',struct('L',0.0125,'r',0.0068,'t',0.001),'tetthet',7700);
T3 = struct('param',struct(),'antallRLCgrener',1,'transformator','ja','tuning','ja','innkapsling','ja','dim',struct('L',0.008,'r',0.0068,'t',0.001),'tetthet',7700);

T = getMeasuredValues(T2);


% T.param.L_t = 1.0e-3;
% T.param.L_t_Rs = 33; % nr L_t = 1,0 mH 

% T.param.L_t = 1.2e-3;
% T.param.L_t_Rs = 8; % nr L_t = 1,2 mH 

% T.param.L_t = 1.8e-3;
% T.param.L_t_Rs = 55; % nr L_t = 1,8 mH 

%T.param.L_t = 1.2e15;
%T.param.L_t_Rs = 1.2e15; % nr L_t = 1,2 mH 

%% Impedans
farge = 'b'; 

[func ABS_Z] = getValues(T, '|Z|');


%subplot(211);
hold on; 
plot(func/1000,ABS_Z/1000,farge,'LineWidth',1)
grid on; 

xmin = 50;
xmax = 80;
ymin = 0;
ymax = 7.5;

set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Z| [k\Omega]')
xlabel('Frekvens - kHz');

% legendInfo{1} = ['Mledata fra 5 transducere'];
% legendInfo{2} = ['Modellert transducer (1 RLC-gren), C_{p} = ' num2str(T1.param.C_p*1e9,3),'nF, R_{p} = 1 M\Omega, R = ' num2str(T1.param.R,3),'\Omega, L = ' num2str(T1.param.L*1e3,3),'mH, C = ' num2str(T1.param.C*1e9,3),'nF']; 
% legendInfo{3} = ['Modellert transducer (2 RLC-grener), C_{p} = ' num2str(T2.param.C_p*1e9,3),'nF, R_{p} = 1 M\Omega, R_{1} = ' num2str(T2.param.R1,3),'\Omega, L_{1} = ' num2str(T2.param.L1*1e3,3),'mH, C_{1} = ' num2str(T2.param.C1*1e9,3),'nF, R_{2} = ' num2str(T2.param.R2,3),'\Omega, L_{2} = ' num2str(T2.param.L2*1e3,3),'mH, C_{2} = ' num2str(T2.param.C2*1e9,3),'nF'];
% legend(legendInfo);


% detekterer min og max punkter
% [maxtab, mintab] = peakdet(ABS_Z_1/1000, 0.0000000000000001, f/1000);
% plot(mintab(:,1), mintab(:,2), 'g*');
% plot(maxtab(:,1), maxtab(:,2), 'g*');
% detekterer min og max punkter
% [maxtab, mintab] = peakdet(ABS_Z_2/1000, 0.0000000000000001, func/1000);
% plot(mintab(:,1), mintab(:,2), 'r*');
% plot(maxtab(:,1), maxtab(:,2), 'r*');
% title('Impedans');

% Plot av M_v
% subplot(212);
% [func M_v] = getValues(T, 'M_v');
% hold on;
% plot(func/1000,20*log10(M_v),farge,'LineWidth',1)
% xlabel('Frekvens - kHz');
% ylabel('M_{v} - dB re 1 V/\muPa');
% ylim([-200 -160]);
% xlim([xmin xmax]);
% grid on; 

%% Admittans


[func ABS_Y_1] = getValues(T, '|Y|');
[func ABS_Y_2] = getValues(T, '|Y|');

figure(1);
hold on; 
plot(func/1000,ABS_Y_1*-1000,'k','LineWidth',2)
%plot(f/1000,ABS_Y_1*1000,'g','LineWidth',2)
plot(func/1000,ABS_Y_2*1000,'--r','LineWidth',2)
grid on; 
xmin = 50;
xmax = 70;
ymin = 0;
ymax = 6;
set(gca,'xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');

legendInfo{1} = ['Mledata fra 5 transducere'];
legendInfo{2} = ['Modellert transducer (1 RLC-gren): C_{p} = ' num2str(T.param.C_p*1e9,3),'nF, R_{p} = ' num2str(T.param.R_p/1000,3), ' k\Omega,\newline R = ' num2str(T.param.R,3),'\Omega, L = ' num2str(T.param.L*1e3,3),'mH, C = ' num2str(T.param.C*1e9,3),'nF']; 
%legendInfo{3} = ['Modellert transducer (2 RLC-grener):\newline C_{p} = ' num2str(T2.param.C_p*1e9,3),'nF, R_{p} = 10 k\Omega, R_{1} = ' num2str(T2.param.R1,3),'\Omega, L_{1} = ' num2str(T2.param.L1*1e3,3),'mH, C_{1} = ' num2str(T2.param.C1*1e9,3),'nF,\newline R_{2} = ' num2str(T2.param.R2,3),'\Omega, L_{2} = ' num2str(T2.param.L2*1e3,3),'mH, C_{2} = ' num2str(T2.param.C2*1e9,3),'nF'];
legend(legendInfo);
title('Admittans');
lh=findall(gcf,'tag','legend');
set(lh,'location','northoutside');


% detekterer min og max punkter
% [maxtab, mintab] = peakdet(ABS_Y_1*1000, 0.0000000000000001, f/1000);
% plot(mintab(:,1), mintab(:,2), 'g*');
% plot(maxtab(:,1), maxtab(:,2), 'g*');
% detekterer min og max punkter
[maxtab, mintab] = peakdet(ABS_Y_2*1000, 0.0000000000000001, func/1000);
plot(mintab(:,1), mintab(:,2), 'r*');
plot(maxtab(:,1), maxtab(:,2), 'r*');




%% Plot av admittanssirkel
T = T1;
[reY1 imY1] = getValues(T, 'sirkel');
T = T2;
[reY2 imY2] = getValues(T, 'sirkel');


figure(3);
hold on;
plot(-reY1*1000,-imY1*1000,'k','LineWidth',2);
%plot(reY1*1000,imY1*1000,'g','LineWidth',2);
plot(reY2*1000,imY2*1000,'--r','LineWidth',2);
grid on; 
xmin = 0;
xmax = 25;
ymin = -10;
ymax = 15;

set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax])
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax])
ylim([ymin ymax])
ylabel('Im(Y) [mS]')
xlabel('Re(Y) [mS]');

% legendInfo{1} = ['Mledata fra 5 transducere'];
% legendInfo{2} = ['Modellert transducer (1 RLC-gren), C_{p} = ' num2str(T1.param.C_p*1e9,3),'nF, R_{p} = 1 M\Omega, R = ' num2str(T1.param.R,3),'\Omega, L = ' num2str(T1.param.L*1e3,3),'mH, C = ' num2str(T1.param.C*1e9,3),'nF']; 
% legendInfo{3} = ['Modellert transducer (2 RLC-grener), C_{p} = ' num2str(T2.param.C_p*1e9,3),'nF, R_{p} = 1 M\Omega, R_{1} = ' num2str(T2.param.R1,3),'\Omega, L_{1} = ' num2str(T2.param.L1*1e3,3),'mH, C_{1} = ' num2str(T2.param.C1*1e9,3),'nF, R_{2} = ' num2str(T2.param.R2,3),'\Omega, L_{2} = ' num2str(T2.param.L2*1e3,3),'mH, C_{2} = ' num2str(T2.param.C2*1e9,3),'nF'];
% legend(legendInfo);
title('Admittanssirkler');

%% Plot av konduktans og suseptans
figure(1);
T = T3;
[func reY] = getValues(T, 'Re(Y)');
[func imY] = getValues(T, 'Im(Y)');


subplot(2,1,1)
plot(func/1000,reY*1000,'--r','LineWidth',3)
grid on;
xmin = 60;
xmax = 80;
ymin = 0;
ymax = 20;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('Re(Y) [mS]')
xlabel('Frekvens - kHz');
title('Konduktans');

subplot(2,1,2)
plot(func/1000,imY*1000,'--r','LineWidth',3)
grid on; 
xmin = 1;
xmax = 41;
ymin = 0;
ymax = 1.5;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('Im(Y) [mS]')
xlabel('Frekvens - kHz');
title('Suseptans');
%legend('Mledata fra 5 transducere','Modellert transducer')

 %% Plot av M_v
T = T3;

[func M_v] = getValues(T, 'M_v');

hold on;
plot(func/1000,20*log10(M_v),'--r','LineWidth',2)
xlabel('Frekvens - kHz');
ylabel('M_{v} - dB re 1 V/\muPa');
ylim([-240 -150]);
xlim([40 90]);
grid on; 

%% sammenligning med Haskin & Walsh sin modell
%% Admittans for 12,5 mm

figure(1);
hold on; 


f_r1 = 65.4;
f_l1 = 126.8;
f_l3 = 370.2;
f_l5 = 615.7;
f_l7 = 861.9;

grid on; 
xmin = 10;
xmax = 1000;
ymin = 0;
ymax = 100;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])

yL = get(gca,'YLim');
line([f_r1 f_r1],yL,'Color','r','LineStyle','--','LineWidth',1);
line([f_l1 f_l1],yL,'Color','k','LineStyle','--','LineWidth',1);
line([f_l3 f_l3],yL,'Color','r','LineStyle','--','LineWidth',1);
line([f_l5 f_l5],yL,'Color','k','LineStyle','--','LineWidth',1);
line([f_l7 f_l7],yL,'Color','r','LineStyle','--','LineWidth',1);
%line([f_l1 f_l1],yL,'Color','r','LineStyle','--','LineWidth',1);
legend(['radiellmodus (n = 1, f = ' num2str(f_r1),' kHz)'],['lengdemodus (n = 1, f = ' num2str(f_l1),' kHz)'],['lengdemodus (n = 3, f = ' num2str(f_l3),' kHz)'],['lengdemodus (n = 5, f = ' num2str(f_l5),' kHz)'],['lengdemodus (n = 7, f = ' num2str(f_l7),' kHz)'])
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');

title('Predikterte resonansfrekvenser sammenlignet med mlte');

%% sammenligning med Haskin & Walsh sin modell
%% Admittans for 8 mm

figure(1);
hold on; 


f_r1 = 66.6;
f_l1 = 193.7;

grid on; 
xmin = 60;
xmax = 200;
ymin = 0;
ymax = 120;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])

yL = get(gca,'YLim');
line([f_r1 f_r1],yL,'Color','r','LineStyle','--','LineWidth',1);
line([f_l1 f_l1],yL,'Color','k','LineStyle','--','LineWidth',1);

%line([f_l1 f_l1],yL,'Color','r','LineStyle','--','LineWidth',1);
legend(['radiellmodus (n = 1, f = ' num2str(f_r1),' kHz)'],['lengdemodus (n = 1, f = ' num2str(f_l1),' kHz)']);
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');

title('Predikterte resonansfrekvenser sammenlignet med mlte');

%% admittansrutenett - trenger bare  kjre denne
figure(1);
grid on; 
xmin = 10;
xmax = 100;
ymin = 0;
ymax = 25;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');
title('Admittans');

%% impedansrutenett - trenger bare  kjre denne
figure(2);
hold on; 
grid on; 
xmin = 40;
xmax = 80;
ymin = 0;
ymax = 4;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Z| [k\Omega]')
xlabel('Frekvens - kHz');
%title('Tuning 1,36 mH, full innkapsling og mlt i luft')
%% kapasitans - trenger bare  kjre denne
figure(2);
hold on; 
grid on; 
xmin = 10;
xmax = 100;
ymin = -40;
ymax = 60;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('C_{f} [nF]')
xlabel('Frekvens - kHz');
title('Kapasitans')

%% impedansrutenett - bndbredde
figure(2);
hold on; 
grid on; 
xmin = 40;
xmax = 90;
ymin = 0;
ymax = 4;



set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])

ylabel('|Z| [k\Omega]')
xlabel('Frekvens - kHz');
title('Impedans')

f_r = 66.57;
k_eff = 0.317;
B = f_r*k_eff;
yL = get(gca,'YLim');
line([f_r-B/2 f_r-B/2],yL,'Color','r','LineStyle','--');
line([f_r+B/2 f_r+B/2],yL,'Color','r','LineStyle','--');



%% admittanssirkelrutenett - trenger bare  kjre denne
figure(3);
hold on;
grid on; 
xmin = 0;
xmax = 2;
ymin = -1.2;
ymax = 0.8;

set(gca,'Xtick',[xmin:(xmax-xmin)/5:xmax])
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/5:ymax])
ylim([ymin ymax])
ylabel('Im(Y) [mS]')
xlabel('Re(Y) [mS]');
%title('Admittanssirkel');

%% Karakterisering av piezoelektriskeparameterverdier fra Ebenezer 
hold on; 
clear; clc; 
a = 0.0068;
L = 0.0125;
h = 0.001; 
rho = 7750; 
%fr = 66570;
%fl = 193000; 
s_11 = 16.3e-12;
s_12 = -5.74e-12; 
%beta = (1*pi*a/L)^2;
%psi = (fr/fl)^2
%sigma = sqrt(1-psi*(1+beta)+psi^2*beta);

sigma = -s_12/s_11;

s_12 = -5.74e-12;
K_33_t = 1780;
e_0 = 8.854187817e-12; 
e_33_t = K_33_t*e_0;
d_31 = -171*1e-12; 



C1 = 2*pi*a*L*e_33_t/h; 
c_sqrd = 1/(rho*s_11);
c = sqrt(c_sqrd);
k_31_sqrd = d_31^2/(e_33_t*s_11);
k_31 = sqrt(k_31_sqrd);

 N = 10000; 
 f_min = 100; %kHz
 f_max = 200; %kHz 

 f = (f_min:(f_max-f_min)/N:f_max)*1000;
 w = 2*pi*f;      

for j = 1:N+1,
    OMEGA(j)= w(j)*a/c;
    alpha1(j)= 1-(1-sigma^2)*OMEGA(j)^2;
    alpha2(j)=1 - OMEGA(j)^2;
    alpha3(j)=1-(1+sigma)*OMEGA(j)^2;
    alpha4(j)=1 - k_31_sqrd - (1+sigma)*(1-sigma-2*k_31_sqrd)*OMEGA(j)^2;
    cR(j) = sqrt(c_sqrd*alpha2(j)/alpha1(j));
    K(j) = w(j)/cR(j);
    
    Y(j) = i*w(j)*C1*(alpha4(j)/alpha1(j) + k_31_sqrd*alpha3(j)^2*tan(K(j)*L/2)/(alpha1(j)*alpha2(j)*K(j)*L/2) );
end

plot(f/1000,abs(Y)*1000,'r');
grid on; 
xmin = f_min;
xmax = f_max;
ymin = 0;
ymax = 125;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');
title('Admittans');


%% Karakterisering av piezoelektriskeparameterverdier fra Haskin & Walsh 
clear; clc; 
hold on; 
a = 0.0068;
l = 0.0125;
t = 0.001; 
rho = 7750; 
s_11 = 16.3e-12;
s_12 = -5.74e-12; 


sigma = -s_12/s_11;
K_33_t = 1780;
e_0 = 8.854187817e-12; 
e_33_T = K_33_t*e_0;
d_31 = -171e-12; % m vre positiv her


Y = 1/s_11; 
c_sqrd = 1/(rho*s_11);
c = sqrt(c_sqrd);
w_ring = c/a;
f_ring = w_ring/(2*pi);

k_B = d_31*sqrt(Y/e_33_T);

k_D = d_31*sqrt(2*Y/((1-sigma)*e_33_T));
k_D_temp1 = sqrt(2*k_B^2/(1-sigma));


e_33_LCC = e_33_T*(1-k_D^2);
e_33_LCC_temp = e_33_T *(1 - 2*d_31^2*Y/((1-sigma)*e_33_T) );

C1 = 2*pi*a*l*e_33_T/t;
C0 = 2*pi*a*l*e_33_LCC/t;

 N = 100000; 
 f_min = 100; %kHz
 f_max = 200; %kHz 

 f = (f_min:(f_max-f_min)/N:f_max)*1000;
 w = 2*pi*f;      

 
 
for j = 1:N+1,
    w_norm(j) = w(j)/w_ring; 
    k(j) = sqrt((w(j)^2/c^2) * ((1-sigma^2)*w_norm(j)^2 - 1) / (w_norm(j)^2-1));
    func(j) = (1-sigma^2)*w_norm(j)^2-1;
    Y(j) = i*w(j)*k_B^2*C1/func(j) * (((((1+sigma)*w_norm(j)^2-1)^2)/(w_norm(j)^2-1))*((tan(k(j)*l/2))/(k(j)*l/2))-(1+sigma)/(1-sigma)) + i*w(j)*C0;
end

plot(f/1000,abs(Y)*1000,'--b');
grid on; 
xmin = f_min;
xmax = f_max;
ymin = 0;
ymax = 125;
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Y| [mS]')
xlabel('Frekvens - kHz');
title('Admittans');

%% Karakterisering av piezoelektriske konstanter fra Haskin & Walsh - TESTING av VERDIER
clear; clc; 
%hold on; 
a = 0.0068;
l = 0.0125;
t = 0.001; 
rho = 7700; 
s_11 = 15.751*(1-i*0.0015)*1e-12;

s_12 = - 5.41*(1+i*0.0015)*1e-12;
sigma = -s_12/s_11; 


K_33_t = 1773;%*(1-i*0.004);
e_0 = 8.854187817e-12; 
e_33_T = K_33_t*e_0;
%d_31 = -171e-12; % m vre positiv her
d_31 = 171e-12; % m vre positiv her

k_31_sqrd = d_31^2/(e_33_T*s_11);
k_31 = sqrt(k_31_sqrd);

Y = 1/s_11; 
c_sqrd = 1/(rho*s_11);
c = sqrt(c_sqrd);
w_ring = c/a;
f_ring = w_ring/(2*pi);

k_B = d_31*sqrt(Y/e_33_T);

k_D = d_31*sqrt(2*Y/((1-sigma)*e_33_T));
k_D_temp1 = sqrt(2*k_B^2/(1-sigma));


e_33_LCC = e_33_T*(1-k_D^2);
e_33_LCC_temp = e_33_T *(1 - 2*d_31^2*Y/((1-sigma)*e_33_T) );

C1 = 2*pi*a*l*e_33_T/t;
C0 = 2*pi*a*l*e_33_LCC/t;

 N = 100000; 
 f_min = 40; %kHz
 f_max = 90; %kHz 

 f = (f_min:(f_max-f_min)/N:f_max)*1000;
 w = 2*pi*f;      

 %L_t = 1.2e-3; % lengde 8 mm
 L_t = 674e-6; % lengde 12,5 mm
 %L_t = 1.2e-3; % ikke tilkoblet
 
for j = 1:N+1,
    w_norm(j) = w(j)/w_ring; 
    k(j) = sqrt((w(j)^2/c^2) * ((1-sigma^2)*w_norm(j)^2 - 1) / (w_norm(j)^2-1));
    func(j) = (1-sigma^2)*w_norm(j)^2-1;
    Y(j) = i*w(j)*k_B^2*C1/func(j) * (((((1+sigma)*w_norm(j)^2-1)^2)/(w_norm(j)^2-1))*((tan(k(j)*l/2))/(k(j)*l/2))-(1+sigma)/(1-sigma)) + i*w(j)*C0 + 1/((i*w(j)*L_t)+8) + w(j)*C1*0.02 ;
    Z(j)= 1/Y(j);
end

% plot(f/1000,-abs(Y)*1000,'k','LineWidth',1);
% plot(f/1000,abs(Y)*1000,'--r','LineWidth',1)

%legend('Mlte verdier','Modell')
% grid on; 
% xmin = f_min;
% xmax = f_max;
% ymin = 0;
% ymax = 8;
% set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
% xlim([xmin xmax])
% set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
% ylim([ymin ymax])
% ylabel('|Y| [mS]')
% xlabel('Frekvens - kHz');
% title('Admittans');
%% Impedans plot
figure(2);
hold on; 
grid on; 
xmin = f_min;
xmax = f_max;
ymin = 0;
ymax = 16;
plot(f/1000,abs(Z)/1000,'--b');
set(gca,'Xtick',[xmin:(xmax-xmin)/10:xmax]);
xlim([xmin xmax])
set(gca,'Ytick',[ymin:(ymax-ymin)/10:ymax]);
ylim([ymin ymax])
ylabel('|Z| [k\Omega]')
xlabel('Frekvens - kHz');
title('Impedans')