%% 8 mm transducer
clear; clc;
r = 6.8e-3;
L = 8e-3;
t = 1e-3;
A = 2*pi*r*L; 

% uten innkapsling
% rho = 7700;
% e33 = 1.57e-8;
% s11 = 1.6054e-11
% d31 = 1.5920e-10
% R = 57.41;


% med ABS-tupp innkapsling i luft
rho = 7700;
e33 = 1.4833e-8;
s11 = 1.9762e-11
d31 = 1.3641e-10
R = 57.41 + 237; 



% med ABS-tupp innkapsling i vann
% rho = 7700;
% e33 = 1.4833e-8;
% s11 = 1.9762e-11
% d31 = 1.3641e-10
% R = 57.41 + 237 +817; 



% med tuning
% L_spole = 1.36e-3; 
% L_res = 30;
% L_spole = 1.8e-3; 
% L_res = 55;
% L_spole = 1.2e-3; 
% L_res = 8;
% L_spole = 1.0e-3; 
% L_res = 36;
% L_spole = 1.36e-3; 
% L_res = 60;
% uten tuning
L_spole = 1.36e20; 
L_res = 1e20;

% L_spole = 2e-3; 
% L_res = 30;
farge  = 'b'; 
%tittel = 'L_{t} = 1,8 mH (indre motstand i spole p 55 \Omega)';
%tittel = 'R = ( 57 + 237 + 817) \Omega = 1111 \Omega';
tittel = '';

k31 = d31*sqrt(1/(e33*s11))
M = 2*pi*rho*r*L*t
K = 2*pi*L*t/(s11*r)

Cp = 2*pi*r*L*e33*(1-k31^2)/t;
Cm = 1/K;
N = 2*pi*L*d31/s11;
Cf = Cp + N^2*Cm;
Rm = R*N^2; 

R_temp = R;
L_temp = M/N^2;
C_temp = Cm*N^2;
%%%%%%%%%%%%%%%%%%%%%% plotting %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_samples = 10000; 
f_min = 40; %kHz
f_max = 80; %kHz 
f = (f_min:(f_max-f_min)/N_samples:f_max)*1000;
w = 2*pi*f;  

 

% Med alt 
for j = 1:N_samples+1,
    
    % Z_r = R_r + i*w*M_r
    %[Rr(j) Mr(j)] = getRadiationResistance(f(j), L, r);  % Innputt - nsket frekvend, lendge og radius til sylinder
    %Z_r(j) = Rr(j) + i*w(j)*Mr(j);
    Rp(j) = 1/(w(j)*Cf*0.007);
     Z_tuning(j) = i*w(j)*L_spole + L_res; 
%     Rr(j) = 70; Mr(j) = 0; Z_r(j) = Rr(j)+i*w(j)*Mr(j); 
   
    %%%%%%%%% flgende uttrykk kan justeres: 
    
    %%%%%%%%% flgende uttrykk kan justeres: 
    % Deaktiver Zr og Zinn: 
    %Rr(j) = 0; Mr(j) = 0; Z_r(j) = Rr(j)+i*w(j)*Mr(j); 
  
    % Deaktiver tuning: 
    %Z_tuning(j) = 1.2e15;
  
    % Deaktiver dielektrisk tap: 
    %Rp(j) = 0;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    Ze(j) = 1/(i*w(j)*Cp + 1/Rp(j) + 1/Z_tuning(j) ) ; 
    Zm(j) = i*w(j)*M + K/(i*w(j)) + Rm; 
    
    Z(j) = Ze(j)*(Zm(j)/N^2)/(Ze(j)+(Zm(j)/N^2));
    Y(j) = 1/Z(j);
    
    Mv(j) = (A/N) * Ze(j)/(Ze(j) + Zm(j)/N^2 );
    %Sv(j) = (i*w(j)*1000/(4*pi))*A*N/(Zm(j)+Z_r(j));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(1)
% % Plott av impedans
% %subplot(211);
% hold on; 
% plot(f/1000,abs(Z)/1000,farge);
% plot(f/1000,-abs(Z)/1000-5,'k');
% grid on; 
% ylabel('|Z| [k\Omega]')
% xlabel('Frekvens - kHz');
% xmin = 40;
% xmax = 80;
% ymin = -0.5;
% ymax = 4.5;
% set(gca,'Xtick',[xmin:(xmax-xmin)/5:xmax]);
% xlim([xmin xmax])
% set(gca,'Ytick',[ymin:(ymax-ymin)/5:ymax]);
% ylim([ymin ymax])
% %legend('Modell','Mlt med HP4194A ');
% title(tittel);

% Plott av admittans
% subplot(312);
% hold on; 
% plot(f/1000,abs(Y)*1000,farge);
% grid on; 
% ylabel('|Y| [mS]')
% xlabel('Frekvens - kHz');
% 
% set(gca,'Xtick',[xmin:(xmax-xmin)/5:xmax]);
% xlim([xmin xmax])


% Plott av mottakersenitivitet
%subplot(212);
figure(1)
hold on; 
plot(f/1000, 20*log10(abs(Mv/1e6)),farge);
xlabel('Frekvens - kHz');
ylabel('M_{v} - dB re 1 V/\muPa');
grid on; 

ymin = -200;
ymax = -170;
set(gca,'Xtick',[f_min:(f_max-f_min)/5:f_max]);
xlim([f_min f_max])
% set(gca,'Ytick',[ymin:(ymax-ymin)/5:ymax]);
% ylim([ymin ymax])
title(tittel);
%title(tittel);
% % Plott av mottakersenitivitet
% subplot(414);
% hold on; 
% plot(f/1000, 20*log10(abs(Sv*1e6)),farge);
% xlabel('Frekvens - kHz');
% ylabel('S_{v} - dB re 1 \muPa/V');
% grid on; 


% figure(2)
% hold on; 
% % admittanssirkel
% plot(real(Y)*1000,imag(Y)*1000,farge);
% grid on; 
% ylabel('Im(Y) [mS]')
% xlabel('Re(Y) [mS]');

% figure(3)
% hold on; 
% plot(f/1000, Rp/1000,farge);
% xlabel('Frekvens - kHz');
% ylabel('R_{p} [k\Omega]');
% grid on; 


