clear; clc;


L1 = 12.5e-3;
L2 = 8e-3;
r1 = 6.8e-3;
r2 = 19.0e-3/2;

 N = 100000; 
 f_min = 0; %kHz
 f_max = 150; %kHz 
 f = (f_min:(f_max-f_min)/N:f_max)*1000;
 w = 2*pi*f;  

for j = 1:N+1,
    % Z_r = R_r + j*w*M_r
    [R_r1(j) M_r1(j)] = getRadiationResistance(f(j), L1, r1);  % Innputt - nsket frekvend, lendge og radius til sylinder
    [R_r2(j) M_r2(j)] = getRadiationResistance(f(j), L1, r2);  % Innputt - nsket frekvend, lendge og radius til sylinder
    [R_r3(j) M_r3(j)] = getRadiationResistance(f(j), L2, r1);  % Innputt - nsket frekvend, lendge og radius til sylinder
    [R_r4(j) M_r4(j)] = getRadiationResistance(f(j), L2, r2);  % Innputt - nsket frekvend, lendge og radius til sylinder
end


subplot(211)
hold on; 
plot(f/1000, R_r1,'r');
plot(f/1000, R_r2,'--b');
plot(f/1000, R_r3,':k');
plot(f/1000, R_r4,'-.g');
ylabel('R_{r} [\Omega]')
xlabel('Frekvens - kHz');
title('Strlingsmotstanden: Z_{r} = R_{r} + j\omegaM_{r}')

hold off; 
grid on; 

subplot(212)
hold on; 
plot(f/1000, M_r1*1000,'r');
plot(f/1000, M_r2*1000,'--b');
plot(f/1000, M_r3*1000,':k');
plot(f/1000, M_r4*1000,'-.g');
ylabel('M_{r} [mH]')
xlabel('Frekvens - kHz');
legend('r = 6,8 mm, L = 12,5 mm', 'r = 9,5 mm, L = 12,5 mm', 'r = 6,8 mm, L = 8 mm', 'r = 9,5 mm, L = 8 mm');
hold off; 
grid on; 